---
sidebar_position: 1
---

# Introducing Steward

Steward's goal is to be a helpful framework for building server-side experiences with Dart.

## Steward's Parts

Steward is comprised of five main parts.

- The CLI
- The Router
- The Container
- Controllers
- The App

You'll learn more about each of these in their own respective documentation.

## Examples

The best examples for how to use Steward are captured in the test folder. Eventually, we'll refactor this out into tests and examples separately, but for now, they live together :)

Using the Steward framework gives you the following (but not limited to) benefits:

- A modular system with light Dependency Injection, Routing, Controllers, and more.
- Automatic dependency injection into controllers when mounting into routers.
- Easy HTTP request/response management.
- Config parsing into the DI container at application boot.
- Templating via the Mustache template specification.
